/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// About.cpp : implementation file
//

#include "stdafx.h"
#include "ui.h"
#include "About.h"


// CAbout dialog

IMPLEMENT_DYNAMIC(CAbout, CDialog)

CAbout::CAbout(CWnd* pParent /*=NULL*/)
	: CDialog(CAbout::IDD, pParent)
{

}

CAbout::~CAbout()
{
}

void CAbout::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_IMG_FUNLOGO, imageLogo);
    DDX_Control(pDX, IDC_ABOUT_MSG, staticAboutMsg);
}


BEGIN_MESSAGE_MAP(CAbout, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
    ON_WM_SIZE()
#endif
END_MESSAGE_MAP()


// CAbout message handlers

BOOL CAbout::OnInitDialog()
{
	CString s1;

	//-- set window text title
	s1.LoadString(IDS_ABOUT); SetWindowText(s1);

	CDialog::OnInitDialog(); 

    #if defined(WIN32_PLATFORM_WFSP)
        if (!dlgCommandBar3.Create(this) ||
            !dlgCommandBar3.InsertMenuBar(IDR_MENUBAR_CLOSE)){
                return FALSE;      // failed to create
        } 
        dlgCommandBar3.Show(true);
    #else
        ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
        dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
        dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
        dlgCommandBar.dwFlags = SHCMBF_HMENU;
        dlgCommandBar.nToolBarId = IDM_SK1_CLOSE; 
        dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
        dlgCommandBar.nBmpId = 0; 
        dlgCommandBar.cBmpImages = 0; 
        if(!SHCreateMenuBar(&dlgCommandBar)){
            AfxMessageBox(_T("Cannot create command bar!")); 
            return FALSE;
        }
    #endif

 #if defined WIN32_PLATFORM_WFSP
    if( (GetDeviceCaps(this->GetDC()->GetSafeHdc(),HORZRES) == 320) &&
        (GetDeviceCaps(this->GetDC()->GetSafeHdc(),VERTRES) == 240) )
    {
        // 320x240 screens
        bmpBitmap.LoadBitmap(IDB_BITMAP1);
        imageLogo.SetBitmap(bmpBitmap);
        int leftPosition = (GetDeviceCaps(this->GetDC()->GetSafeHdc(),HORZRES) / 2) - 65; // the middle of 131
        
        imageLogo.SetWindowPos(&CWnd::wndTop, leftPosition,8,0,0, SWP_NOSIZE);
        staticAboutMsg.SetWindowPos(&CWnd::wndTop, 55,120,0,0, SWP_NOSIZE);
    }
    else
    {
	if(GetDeviceCaps(this->GetDC()->GetSafeHdc(), LOGPIXELSX) < 131)
		bmpBitmap.LoadBitmap(IDB_BITMAP1);  // dpi < 131
	else
		bmpBitmap.LoadBitmap(IDB_BITMAP2);  // dpi >= 131
	imageLogo.SetBitmap(bmpBitmap);
    }
 #endif

    //-- load plugin version from Registry
    HKEY key;
    long err=0;
    ULONG dim;
    TCHAR *buf = NULL;

    RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("\\Software\\Funambol\\SyncclientPIM"),
                    0, KEY_READ,  &key);
    if(key != 0)
    {
        // Get value length
        err = RegQueryValueEx(key, PLUGIN_VERSION, NULL, NULL, NULL, &dim);

        if (err == ERROR_SUCCESS) {
            if (dim > 0) {
                buf = new TCHAR[dim + 1];
                err = RegQueryValueEx(key, PLUGIN_VERSION, NULL, NULL,(UCHAR*)buf, &dim);            
            }
        }
    }

    s1.LoadString(IDS_ABOUT_MSG1); 

    CString s2(buf);
    if(s2 != "")
    s1+= s2;

    s2.LoadString(IDS_ABOUT_MSG2);
    s1+=s2; 
    aboutMessage = s1;
    SetDlgItemText(IDC_ABOUT_MSG, aboutMessage); 
    RegCloseKey(key);

    if(buf){
        delete [] buf; buf = NULL;
    }

	return TRUE;
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CAbout::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    int resId;
    switch(DRA::GetDisplayMode())
    {
    case DRA::Landscape:
        resId = IDD_UI_ABOUT_WIDE; break;
    case DRA::Portrait:
        resId = IDD_UI_ABOUT; break;
    case DRA::Square:
        resId = IDD_UI_ABOUT_SQUARE; break;
    default:
        resId = IDD_UI_ABOUT; break;
    };

    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));

    SetDlgItemText(IDC_ABOUT_MSG, aboutMessage);
}
#endif