/*
* Copyright (C) 2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// BriefcaseSettings.cpp : implementation file
//

#include "stdafx.h"
#include "ui.h"
#include "BriefcaseSettings.h"
#include "ExploreFolders.h"

#include "comutil.h"

#include "RegistrySettings.h"
#include "pim/Maincpp.h"	//-- for checkStartSync
#include "tpcshell.h"  //-- for SHSendBackToFocusWindow



// CBriefcaseSettings dialog

IMPLEMENT_DYNAMIC(CBriefcaseSettings, CDialog)

CBriefcaseSettings::CBriefcaseSettings(CWnd* pParent /*=NULL*/)
: CDialog(CBriefcaseSettings::IDD, pParent)
{

}

CBriefcaseSettings::~CBriefcaseSettings()
{
}

void CBriefcaseSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    #if defined(WIN32_PLATFORM_WFSP)
        DDX_Control(pDX, IDC_BRIEFCASE_SPIN1, spinSyncType );
    #endif
	DDX_Control(pDX, IDC_BRIEFCASE_SYNCTYPE, lstSyncType );	
	DDX_Control(pDX, IDC_BRIEFCASE_EDIT_REMOTE, editRemote);
}


BEGIN_MESSAGE_MAP(CBriefcaseSettings, CDialog)
#ifdef WIN32_PLATFORM_WFSP
	ON_MESSAGE(WM_HOTKEY,&CBriefcaseSettings::OnHotkey)
#endif
    ON_COMMAND(ID_MENU_FOLDER, &CBriefcaseSettings::OnMenuFolder)
    #if defined(WIN32_PLATFORM_PSPC)
        ON_BN_CLICKED(IDC_BRIEFCASE_BROWSE, &CBriefcaseSettings::OnClickedBriefcaseBrowse)
    #endif

    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        ON_WM_SIZE()
    #endif
END_MESSAGE_MAP()


// CBriefcaseSettings message handlers

BOOL CBriefcaseSettings::OnInitDialog()
{
	CString s1;

	s1.LoadString(IDS_BRIEFCASE); SetWindowText(s1);
	CDialog::OnInitDialog();	


  #ifdef WIN32_PLATFORM_WFSP
    spinSyncType.SetRange(3,0);  spinSyncType.SetBuddy(&lstSyncType);

	if (!dlgCommandBar3.Create(this) ||
		!dlgCommandBar3.InsertMenuBar(IDR_MENUBAR_SETTBRIEFCASE))
	{
		return FALSE;      // failed to create
	} 
	dlgCommandBar3.Show(true);
  #else
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_BRIEFCASE; 
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!")); 
        return FALSE;
    }
  #endif


 //------------------- read string resources ----------
  editRemote.SetLimitText(EDIT_MAXLENGTH);
  s1.LoadString(IDS_SETTCOMM_SYNCTYPE1);	lstSyncType.AddString(s1); 
  s1.LoadString(IDS_SETTCOMM_SYNCTYPE2);	s1+= " Briefcase";	lstSyncType.AddString(s1); 
  s1.LoadString(IDS_SETTCOMM_SYNCTYPE3);	s1+= " Briefcase";	lstSyncType.AddString(s1); 
  s1.LoadString(IDS_SETTCOMM_SYNCTYPE4);	s1+= " Briefcase";	lstSyncType.AddString(s1); 
  s1.LoadString(IDS_SETTCOMM_SYNCTYPE5);	s1+= " Briefcase";	lstSyncType.AddString(s1); 

  s1.LoadString(IDS_SYNCTYPE); SetDlgItemText(IDC_BRIEFCASE_STATIC_SYNCTYPE,s1);
  s1.LoadString(IDS_REMOTENAME); SetDlgItemText(IDC_BRIEFCASE_STATIC_REMONAME,s1);
  s1.LoadString(IDS_FOLDER_TO_SYNC); SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER,s1);
  

 //----- init values with values read from the registry -------
 SyncRegSettings regsettings("briefcase");
 CString s3; int pos=0;
    
 s3 = regsettings.cs.ssconfig.getURI(); SetDlgItemText(IDC_BRIEFCASE_EDIT_REMOTE,s3);
 pos = SynctypeReg2UI(regsettings.cs.ssconfig.getSync()); 
 lstSyncType.SetCurSel(pos);

 #if defined(WIN32_PLATFORM_WFSP)
     //-- override back key
      LPARAM lparam = MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY,
			SHMBOF_NODEFAULT | SHMBOF_NOTIFY);
      ::SendMessage(dlgCommandBar3, SHCMBM_OVERRIDEKEY, VK_TBACK, lparam);
 #endif

 s3 = regsettings.cs.getDir();
 
 if (s3 == "") {
    // default
    LPTSTR dir = new  WCHAR[512];    
    SHGetSpecialFolderPath(NULL, dir, CSIDL_PERSONAL, FALSE);
    wstring s(dir);
    delete [] dir;
    wstring brief = s; brief += L"\\briefcase";
    if (existsDirectory((wchar_t*)brief.c_str())) {
        s3 = brief.c_str();
    } else {
        s3 = s.c_str();
    }  
 }
 
 folder = s3;
 s1.LoadString(IDS_FOLDER_TO_SYNC);
 s1+=s3;
 SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER,s1);
 //SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER,CString("pippo"));
 s3.LoadString(IDS_BRIEFCASE_CHOOSE_FOLDER);

 //-- set a large int as current selection, so the cursor will be at end
 editRemote.SetSel(0);  //editRemote.SetSel(LARGE_INT ,LARGE_INT);  
 lstSyncType.SetFocus();
 return FALSE;  // set focus to listbox
}


void CBriefcaseSettings::OnOK()
{
  //-- save values in registry
  SyncRegSettings regsettings("briefcase", false);
  CString s1; int pos=0; 
  _bstr_t bst; 

  GetDlgItemText(IDC_BRIEFCASE_EDIT_REMOTE, s1); 
  bst=s1.AllocSysString();
  regsettings.cs.ssconfig.setURI((char*)bst);
  bst.Detach();

  pos = lstSyncType.GetCurSel();
  regsettings.cs.ssconfig.setSync(SynctypeUI2Reg(pos));

  if(folder == _T("")) {
       folder = regsettings.cs.getDir();
  }
  bst = folder.AllocSysString();
  regsettings.cs.setDir(folder);
  // bst.Detach(); 

  if(! checkStartSync()){
      regsettings.writeToRegistry("briefcase", false);
  }
  CDialog::OnOK();
}

#ifdef WIN32_PLATFORM_WFSP
LRESULT CBriefcaseSettings::OnHotkey(WPARAM wParam, LPARAM lParam)
{
	if (HIWORD(lParam) == VK_TBACK)
		SHSendBackToFocusWindow(WM_HOTKEY, wParam, lParam);
	return 0;
}
#endif

void CBriefcaseSettings::OnMenuFolder()
{
  #ifdef WIN32_PLATFORM_WFSP
    dlgCommandBar3.Show(false);
  #endif
    CExploreFolders wndExplore;

    #if defined(WIN32_PLATFORM_PSPC) 
        wndExplore.setIsNotes(false);
    #endif

    INT_PTR result = wndExplore.DoModal();
    if (result == IDCHOOSE)
    {
        //--user has chosen a new folder
        CString folderToSync = wndExplore.getFolder();
        CString s1;
        s1.LoadString(IDS_FOLDER_TO_SYNC);
        s1+=folderToSync;
        this->folder = folderToSync;
        SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER, s1);   
    }

    #if defined(WIN32_PLATFORM_WFSP)
        dlgCommandBar3.Show(true);
    #endif
}

void CBriefcaseSettings::OnClickedBriefcaseBrowse()
{
    this->OnMenuFolder(); 
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CBriefcaseSettings::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    int resId;
    switch(DRA::GetDisplayMode())
    {
    case DRA::Landscape:
        resId = IDD_UI_BRIEFCASE_WIDE; break;
    case DRA::Portrait:
        resId = IDD_UI_BRIEFCASE; break;
    case DRA::Square:
        resId = IDD_UI_BRIEFCASE_SQUARE; break;
    default:
        resId = IDD_UI_BRIEFCASE; break;
    };

    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));

    CString s1, s3;
    SyncRegSettings regsettings("briefcase");

    s1.LoadString(IDS_SYNCTYPE); SetDlgItemText(IDC_BRIEFCASE_STATIC_SYNCTYPE,s1);
    s1.LoadString(IDS_REMOTENAME); SetDlgItemText(IDC_BRIEFCASE_STATIC_REMONAME,s1);
    s1.LoadString(IDS_FOLDER_TO_SYNC); SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER,s1);
   
    s1.LoadString(IDS_FOLDER_TO_SYNC);
    s1+=folder;
    SetDlgItemText(IDC_BRIEFCASE_STATIC_FOLDER,s1);
}
#endif
