/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "stdafx.h"
#include "pim/maincpp.h"
#include "pim/SettingFunctions.h"
#include "base/startcmd.h"
#include "notify/timed_msgbox.h"
#include "HwndFunctions.h"

// items in listboxes MUST be load in this order
int SynctypeReg2UI(const char* sSyncType)
{
	int pos = 0; // TODO: maybe set pos to -1 to detect invalid data in registry

	if(! strcmp(sSyncType,"two-way"))
		pos=0;
	if(! strcmp(sSyncType,"refresh-server"))
		pos=1;
	if(! strcmp(sSyncType,"refresh-client"))
		pos=2;
	if(! strcmp(sSyncType, "one-way-server"))
		pos=3;
	if(! strcmp(sSyncType,"one-way-client"))
		pos=4;

	return pos;
}


const char* SynctypeUI2Reg(int nPos)
{
	switch(nPos)
	{
	case 0:
        return "two-way"; 
	case 1:
        return "refresh-server"; 
	case 2:
        return "refresh-client"; 
	case 3:
        return "one-way-server";
	case 4:
        return "one-way-client";
	}

    // should not get here
    return "";
}


/**
 * @return -1= NO, 0:YES, 1=Not running
 */
int EndAppQuery(HWND wndUIWindow)
{
    int ret = -1;
    CString s1;
    
    HWND wnd = ::FindWindow(TEXT("funambolstartsync"), NULL);
    if (checkStartSync() != 0)
    {
        // sync is in progress
        HwndFunctions::closePreviousMsgBox();
        //s1.LoadString(IDS_INTERRUPT_SYNC);
        s1 = "Do you really want to interrupt the synchronization?";
        int retMsgBox = TimedMessageBox(NULL, s1, TEXT("Funambol alert"),
            MB_YESNO | MB_ICONQUESTION | MB_SETFOREGROUND, 10 * 1000);

        if(retMsgBox == IDYES)
        {
            //-- send msg to startsync to stop
            if(wnd)
                ::SendMessage(wnd, WM_COMMAND, (WPARAM)10, NULL);

            // The user answered YES
            return 0;
        }
    }
    else {
        // The process is not running
        return 1;
    }
    // The user answered no
    return -1;
}

BOOL existsDirectory(wchar_t* dir) {

    WIN32_FIND_DATA FileData;
    BOOL ret = TRUE;
    HANDLE hFind;   

    hFind = FindFirstFile(dir, &FileData);
    
    if (hFind == INVALID_HANDLE_VALUE) {        
        ret = FALSE;
    } else {
        ret = TRUE;
    }
    if (hFind) {
        FindClose(hFind);
    }

    return ret;
}