/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// MailFiltersSettings.cpp : implementation file
//

#include "stdafx.h"
#include "ui.h"
#include "MailFiltersSettings.h"
#include "RegistrySettings.h"
#include "pim/Maincpp.h"

// CMailFiltersSettings dialog

IMPLEMENT_DYNAMIC(CMailFiltersSettings, CDialog)

CMailFiltersSettings::CMailFiltersSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CMailFiltersSettings::IDD, pParent)
{
}

CMailFiltersSettings::~CMailFiltersSettings()
{
}

void CMailFiltersSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    #if defined(WIN32_PLATFORM_WFSP)
        DDX_Control(pDX, IDC_SETTFILTERS_SPIN2, spinMsgSize );
        DDX_Control(pDX, IDC_SETTFILTERS_SPIN3, spinMailSince );
    #endif

    DDX_Control(pDX, IDC_FILTERS_MSGSIZE, lstMsgSize );
    DDX_Control(pDX, IDC_FILTERS_MAILSINCE, lstMailSince );
    DDX_Control(pDX, IDC_FILTERS_ATTACHMENT, checkAttachments );
}


BEGIN_MESSAGE_MAP(CMailFiltersSettings, CDialog)
END_MESSAGE_MAP()


BOOL CMailFiltersSettings::OnInitDialog()
{
  // SET window title
  CString s1,s2;
  s1.LoadString(IDS_FILTERS_SETTINGS); ;SetWindowText(s1);
  CDialog::OnInitDialog(); 

  #if defined(WIN32_PLATFORM_WFSP)
    spinMsgSize.SetRange(4,0); 	 spinMsgSize.SetBuddy(&lstMsgSize);  
    spinMailSince.SetRange(5,0); spinMailSince.SetBuddy(&lstMailSince);  

  if (!dlgCommandBar3.Create(this) ||
      !dlgCommandBar3.InsertMenuBar(IDR_MENUBAR_OKCANCEL))
  {
	//AfxMessageBox(_T("Failed to create CommandBar\n"));
	return FALSE;      // failed to create
  } 
   dlgCommandBar3.Show(true);
 #else
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_OKCANCEL; 
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!")); 
        return FALSE;
    }
 #endif

  //------------------- read string resources ----------
  s1.LoadString(IDS_FILTERS_DOWNMAIL_ALL); lstMailSince.AddString(s1);
  s1.LoadString(IDS_FILTERS_DOWNMAIL_0DAY); lstMailSince.AddString(s1);
  s1.LoadString(IDS_FILTERS_DOWNMAIL_3DAY); lstMailSince.AddString(s1);
  s1.LoadString(IDS_FILTERS_DOWNMAIL_5DAY); lstMailSince.AddString(s1);
  s1.LoadString(IDS_FILTERS_DOWNMAIL_7DAY); lstMailSince.AddString(s1);
  s1.LoadString(IDS_FILTERS_DOWNMAIL_10DAY); lstMailSince.AddString(s1);

  s1.LoadString(IDS_FILTERS_GETMSGSIZE_10K); lstMsgSize.AddString(s1);
  s1.LoadString(IDS_FILTERS_GETMSGSIZE_50K); lstMsgSize.AddString(s1);
  s1.LoadString(IDS_FILTERS_GETMSGSIZE_100K); lstMsgSize.AddString(s1);
  s1.LoadString(IDS_FILTERS_GETMSGSIZE_250K); lstMsgSize.AddString(s1);
  s1.LoadString(IDS_FILTERS_GETMSGSIZE_500K); lstMsgSize.AddString(s1);

  s1.LoadString(IDS_FILTERS_ATTACHMENTS); SetDlgItemText(IDC_FILTERS_ATTACHMENT, s1);

  //----- init values with values read from the registry -------
  SyncRegSettings regsettings("mail");
  CString s3; int pos=0;
	
    pos=0;
    switch(regsettings.cs.mailssconfig.getDownloadAge())
    {
    case -1: pos=0; break;
    case 0: pos=1; break;
    case 3: pos=2; break;
    case 5: pos=3; break;
    case 7: pos=4; break;
    case 10: pos=5; break;
    };
    lstMailSince.SetCurSel(pos);

    pos=0;
    switch(regsettings.cs.mailssconfig.getAttachSize())
    {
    case 10:   pos = 0;  break;
    case 50:   pos = 1;  break;
    case 100:  pos = 2;  break;
    case 250:  pos = 3;  break;
    case -1:   pos = 4;  break;    
    };
    lstMsgSize.SetCurSel(pos);
	
    if(regsettings.cs.mailssconfig.getBodySize() == -1)
        checkAttachments.SetCheck(BST_CHECKED);

    //-- check if another sync is in progress
	/*if (checkStartSync() != 0)
	{
		lstMailSince.EnableWindow(FALSE); spinMailSince.EnableWindow(FALSE);
		lstMsgSize.EnableWindow(FALSE); spinMsgSize.EnableWindow(FALSE);
	} */

    lstMailSince.SetFocus();
	return FALSE;
}

void CMailFiltersSettings::OnOK()
{
	CString s1;
	SyncRegSettings regsettings("mail", false);

    int pos = 0; int value=-1;
    pos = lstMailSince.GetCurSel();
    switch(pos)
    {
    case 0: value=-1;break;
    case 1: value=0;break;
    case 2: value=3;break;
    case 3: value=5;break;
    case 4: value=7;break;
    case 5: value=10;break;
    }
    regsettings.cs.mailssconfig.setDownloadAge(value);

    pos=0; value=-1;
    pos = lstMsgSize.GetCurSel();
    switch(pos)
    {
    case 0: value=10;break;
    case 1: value=50;break;
    case 2: value=100;break;
    case 3: value=250;break;
    case 4: value=-1;break;
    }
    regsettings.cs.mailssconfig.setAttachSize(value);

    // --attachments
    if(checkAttachments.GetCheck() == BST_CHECKED)
        regsettings.cs.mailssconfig.setBodySize(-1);
    else 
        regsettings.cs.mailssconfig.setBodySize(1);

    if(!checkStartSync()){
        regsettings.writeToRegistry("mail", false);
    }

	CDialog::OnOK();
}

