/*
* Copyright (C) 2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// notes are not supported on smartphone



#include "stdafx.h"
#include "ui.h"
#include "NotesSettings.h"
#include "ExploreFolders.h"

#include "comutil.h"

#include "RegistrySettings.h"
#include "pim/Maincpp.h"	//-- for checkStartSync
#include "tpcshell.h"  //-- for SHSendBackToFocusWindow



// CNotesSettings dialog

IMPLEMENT_DYNAMIC(CNotesSettings, CDialog)
#if defined(WIN32_PLATFORM_PSPC)
CNotesSettings::CNotesSettings(CWnd* pParent /*=NULL*/)
: CDialog(CNotesSettings::IDD, pParent)
{

}
#endif

CNotesSettings::~CNotesSettings()
{
}

void CNotesSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
   #if defined(WIN32_PLATFORM_PSPC)
	DDX_Control(pDX, IDC_NOTES_SYNCTYPE, lstSyncType );	
	DDX_Control(pDX, IDC_NOTES_EDIT_REMOTE, editRemote);
   #endif
}


BEGIN_MESSAGE_MAP(CNotesSettings, CDialog)
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        ON_WM_SIZE()
    #endif
    ON_COMMAND(ID_MENU_FOLDER, &CNotesSettings::OnMenuFolder)
    #if defined(WIN32_PLATFORM_PSPC)
        ON_BN_CLICKED(IDC_NOTES_BROWSE, &CNotesSettings::OnClickedNotesBrowse)
    #endif
END_MESSAGE_MAP()


// CNotesSettings message handlers

BOOL CNotesSettings::OnInitDialog()
{
  #if defined(WIN32_PLATFORM_PSPC)
	CString s1;

	s1.LoadString(IDS_NOTES); SetWindowText(s1);
	CDialog::OnInitDialog();	

    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_BRIEFCASE; 
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!")); 
        return FALSE;
    }

	//------------------- read string resources ----------
    editRemote.SetLimitText(EDIT_MAXLENGTH);
	s1.LoadString(IDS_SETTCOMM_SYNCTYPE1);	lstSyncType.AddString(s1); 
	s1.LoadString(IDS_SETTCOMM_SYNCTYPE2);	s1+= " Notes";	lstSyncType.AddString(s1); 
	s1.LoadString(IDS_SETTCOMM_SYNCTYPE3);	s1+= " Notes";	lstSyncType.AddString(s1); 
	s1.LoadString(IDS_SETTCOMM_SYNCTYPE4);	s1+= " Notes";	lstSyncType.AddString(s1); 
	s1.LoadString(IDS_SETTCOMM_SYNCTYPE5);	s1+= " Notes";	lstSyncType.AddString(s1); 

	s1.LoadString(IDS_SYNCTYPE); SetDlgItemText(IDC_NOTES_STATIC_SYNCTYPE,s1);
	s1.LoadString(IDS_REMOTENAME); SetDlgItemText(IDC_NOTES_STATIC_REMONAME,s1);
	s1.LoadString(IDS_FOLDER_TO_SYNC); SetDlgItemText(IDC_NOTES_STATIC_FOLDER,s1);


	//----- init values with values read from the registry -------
	SyncRegSettings regsettings("note");
    //regsettings.cs.getConfigSourcesParameter("note","uri")
	CString s3; int pos=0;
    
	s3 = regsettings.cs.ssconfig.getURI(); 
    SetDlgItemText(IDC_NOTES_EDIT_REMOTE,s3);
    pos = SynctypeReg2UI(regsettings.cs.ssconfig.getSync()); 
	lstSyncType.SetCurSel(pos);

    #if defined(WIN32_PLATFORM_WFSP)
		//-- override back key
		LPARAM lparam = MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY,
			SHMBOF_NODEFAULT | SHMBOF_NOTIFY);
		::SendMessage(dlgCommandBar3, SHCMBM_OVERRIDEKEY, VK_TBACK, lparam);
    #endif
	//}

    s3 = regsettings.cs.getDir();    
    if (s3 == "") {        
        // default
        LPTSTR dir= new WCHAR[256];
        SHGetSpecialFolderPath(NULL, dir, CSIDL_PERSONAL, FALSE);
        s3 = CString(dir);
        delete [] dir;        
    }
    
    folder = s3;
    s1.LoadString(IDS_FOLDER_TO_SYNC);
    s1+=s3;
    SetDlgItemText(IDC_NOTES_STATIC_FOLDER,s1);
    s3.LoadString(IDS_BRIEFCASE_CHOOSE_FOLDER);

	//-- set a large int as current selection, so the cursor will be at end
	editRemote.SetSel(0);  //editRemote.SetSel(LARGE_INT ,LARGE_INT);  
   
    lstSyncType.SetFocus();
  #endif

	return FALSE;  // set focus to listbox
}


void CNotesSettings::OnOK()
{
  #if defined(WIN32_PLATFORM_PSPC)
	//-- save values in registry
	SyncRegSettings regsettings("note", false);
	CString s1; int pos=0; 
	_bstr_t bst; 

	GetDlgItemText(IDC_NOTES_EDIT_REMOTE, s1); 
	bst=s1.AllocSysString();
    regsettings.cs.ssconfig.setURI((char*)bst);
    bst.Detach();

	pos = lstSyncType.GetCurSel();
    regsettings.cs.ssconfig.setSync(SynctypeUI2Reg(pos));

    if(folder == _T("")) {
        folder = regsettings.cs.getDir();
    }
    bst = folder.AllocSysString();
    regsettings.cs.setDir(folder);
    // bst.Detach(); 

    if(!checkStartSync()){
	    regsettings.writeToRegistry("note", false);
    };

	CDialog::OnOK();
 #endif
}

void CNotesSettings::OnMenuFolder()
{
  #if defined(WIN32_PLATFORM_PSPC)
    CExploreFolders wndExplore;
    wndExplore.setIsNotes(true);
    INT_PTR result = wndExplore.DoModal();
    if (result == IDCHOOSE)
    {
        //--user has chosen a new folder
        CString folderToSync = wndExplore.getFolder();
        CString s1;
        s1.LoadString(IDS_FOLDER_TO_SYNC);
        s1+=folderToSync;
        this->folder = folderToSync;
        SetDlgItemText(IDC_NOTES_STATIC_FOLDER, s1);   
    }
  #endif
}

void CNotesSettings::OnClickedNotesBrowse()
{
    this->OnMenuFolder(); 
}


#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CNotesSettings::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    int resId;
    switch(DRA::GetDisplayMode())
    {
    case DRA::Landscape:
        resId = IDD_UI_NOTES_WIDE; break;
    case DRA::Portrait:
        resId = IDD_UI_NOTES; break;
    case DRA::Square:
        resId = IDD_UI_NOTES_SQUARE; break;
    default:
        resId = IDD_UI_NOTES; break;
    };

    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));

    // restore label values
    CString s1, s3;
    SyncRegSettings regsettings("note");

    s1.LoadString(IDS_SYNCTYPE); SetDlgItemText(IDC_NOTES_STATIC_SYNCTYPE,s1);
	s1.LoadString(IDS_REMOTENAME); SetDlgItemText(IDC_NOTES_STATIC_REMONAME,s1);
	s1.LoadString(IDS_FOLDER_TO_SYNC); SetDlgItemText(IDC_NOTES_STATIC_FOLDER,s1);
    
    s1.LoadString(IDS_FOLDER_TO_SYNC);
    s1+=folder;
    SetDlgItemText(IDC_NOTES_STATIC_FOLDER,s1);
}
#endif


//#endif 
//#endif 