/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// PushSettings.cpp : implementation file
//

#include "stdafx.h"
#include "ui.h"
#include "PushSettings.h"
#include "RegistrySettings.h"
#include "comutil.h"

#include "tpcshell.h"  //-- for SHSendBackToFocusWindow

#include "pim/Maincpp.h"
#include "base/startcmd.h"
#include "ClientUtil.h"

#include <string>
using namespace std;

#define SYNCAPP             TEXT("startsync.exe")
#define APP_RUN_AT_TIME     TEXT("AppRunAtTime")

// CPushSettings dialog

IMPLEMENT_DYNAMIC(CPushSettings, CDialog)

CPushSettings::CPushSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CPushSettings::IDD, pParent)
{

}

CPushSettings::~CPushSettings()
{
}

void CPushSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PUSH_CHECK_PUSH, checkServerPush);
	DDX_Control(pDX, IDC_PUSH_CHECK_SMS, checkSms);
	DDX_Control(pDX, IDC_PUSH_CHECK_TCPIP, checkTcpIp);
	DDX_Control(pDX, IDC_PUSH_EDIT_PORT, editPort);
	DDX_Control(pDX, IDC_PUSH_RADIO_YES, radioYes);
	DDX_Control(pDX, IDC_PUSH_RADIO_NO, radioNo);
}


BEGIN_MESSAGE_MAP(CPushSettings, CDialog)
	ON_BN_CLICKED(IDC_PUSH_CHECK_PUSH, &CPushSettings::OnCheckPushClicked)
	ON_BN_CLICKED(IDC_PUSH_CHECK_TCPIP, &CPushSettings::OnPushCheckTcpipClicked)
	#ifdef WIN32_PLATFORM_WFSP
		ON_MESSAGE(WM_HOTKEY,&CPushSettings::OnHotkey)
	#endif
END_MESSAGE_MAP()


// CPushSettings message handlers

BOOL CPushSettings::OnInitDialog()
{
	CString s1;

	//-- set window text title
	s1.LoadString(IDS_PUSH_SETTINGS); SetWindowText(s1);

	CDialog::OnInitDialog(); 
	radioYes.SetCheck(BST_CHECKED);

    #if defined(WIN32_PLATFORM_WFSP)
        if (!dlgCommandBar3.Create(this) ||
            !dlgCommandBar3.InsertMenuBar(IDR_MENUBAR_OKCANCEL)){
                return FALSE;      // failed to create
            } 
        dlgCommandBar3.Show(true);
    #else
        ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
        dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
        dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
        dlgCommandBar.dwFlags = SHCMBF_HMENU;
        dlgCommandBar.nToolBarId = IDM_OKCANCEL; 
        dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
        dlgCommandBar.nBmpId = 0; 
        dlgCommandBar.cBmpImages = 0; 
        if(!SHCreateMenuBar(&dlgCommandBar)){
            AfxMessageBox(_T("Cannot create command bar!")); 
            return FALSE;
        }
    #endif

   //------------------- read string resources ---------- ////
   s1.LoadString(IDS_PUSH_SERVER); SetDlgItemText(IDC_PUSH_CHECK_PUSH, s1);
   s1.LoadString(IDS_PUSH_NOTIFTYPE); SetDlgItemText(IDC_PUSH_STATIC_NOTIFTYPE, s1);
   s1.LoadString(IDS_PUSH_SMS); SetDlgItemText(IDC_PUSH_CHECK_SMS, s1);
   s1.LoadString(IDS_PUSH_TCPIP); SetDlgItemText(IDC_PUSH_CHECK_TCPIP, s1);
   s1.LoadString(IDS_PUSH_PORT); SetDlgItemText(IDC_PUSH_STATIC_PORT, s1);
   s1.LoadString(IDS_PUSH_ASK); SetDlgItemText(IDC_PUSH_STATIC_ASK, s1);
   s1.LoadString(IDS_PUSH_YES); SetDlgItemText(IDC_PUSH_RADIO_YES, s1);
   s1.LoadString(IDS_PUSH_NO); SetDlgItemText(IDC_PUSH_RADIO_NO, s1);


  //------------------- read Registry Settings ---------------------------- //
    CommunicationRegSettings regsettings;	    

	if( (regsettings.cs.getSms() == "1")  ||
		(regsettings.cs.getSms() == "2")  ||
        (regsettings.cs.getPush() == "1")  ||
        (regsettings.cs.getPush() == "2")  )
	{
		checkServerPush.SetCheck(BST_CHECKED);
        //checkSms.SetCheck(BST_CHECKED); //!
	}
	else
	{
		checkServerPush.SetCheck(BST_UNCHECKED);
		checkSms.EnableWindow(FALSE);
		checkTcpIp.EnableWindow(FALSE);
		editPort.EnableWindow(FALSE);
		radioYes.EnableWindow(FALSE);
		radioNo.EnableWindow(FALSE);
	};
	
	//------------ polling
	
	int i=0;  int pos=-1; 

	//---- sms
    if (!regsettings.cs.getIsPortal()) {
        
        if(regsettings.cs.getSms() == "0")
		    checkSms.SetCheck(BST_UNCHECKED);
	    else
		    if( (regsettings.cs.getSms() == "1") || (regsettings.cs.getSms() == "2") )
			    checkSms.SetCheck(BST_CHECKED);
    } else {
        checkSms.EnableWindow(FALSE);
        checkSms.SetCheck(FALSE);
    }
	//------ pushPort
    s1 = regsettings.cs.getPushPort();
	SetDlgItemText(IDC_PUSH_EDIT_PORT, s1);

	//-- TCP/IP
	if(regsettings.cs.getPush() == "0")
	{
		checkTcpIp.SetCheck(BST_UNCHECKED);
		editPort.EnableWindow(FALSE);
	}
	else
		checkTcpIp.SetCheck(BST_CHECKED);
	
	//---- askConfirmation
	
	if( (regsettings.cs.getSms()  == "2") ||
		(regsettings.cs.getPush() == "2") )
		{
			radioYes.SetCheck(BST_CHECKED);
			radioNo.SetCheck(BST_UNCHECKED);
		}
		else
		{
			radioYes.SetCheck(BST_UNCHECKED);
			radioNo.SetCheck(BST_CHECKED);
		};

    #ifdef WIN32_PLATFORM_WFSP
	    //-- override back key
	    LPARAM lparam = MAKELPARAM(SHMBOF_NODEFAULT | SHMBOF_NOTIFY,
		    	SHMBOF_NODEFAULT | SHMBOF_NOTIFY);
	    ::SendMessage(dlgCommandBar3, SHCMBM_OVERRIDEKEY, VK_TBACK, lparam);
    #endif

	//-- set a large int as current selection, so the cursor will be at end
	editPort.SetSel(0);  //editPort.SetSel(LARGE_INT ,LARGE_INT);  

	checkServerPush.SetFocus();
	return FALSE;
}
void CPushSettings::OnCheckPushClicked()
{
    CommunicationRegSettings regsettings;	    

	if(checkServerPush.GetCheck() == BST_CHECKED)
	{
        if (!regsettings.cs.getIsPortal()) {
		    checkSms.EnableWindow(TRUE);
        } else {
            checkSms.EnableWindow(FALSE);
            checkSms.SetCheck(FALSE);
        }
        //checkSms.SetCheck(BST_CHECKED);
		checkTcpIp.EnableWindow(TRUE);
		if(checkTcpIp.GetCheck() == BST_CHECKED)
			editPort.EnableWindow(TRUE);
		else
			editPort.EnableWindow(FALSE);
		radioYes.EnableWindow(TRUE);
		radioNo.EnableWindow(TRUE);
	}
	else
	{
		checkSms.EnableWindow(FALSE);
		checkTcpIp.EnableWindow(FALSE);
		editPort.EnableWindow(FALSE);
		radioYes.EnableWindow(FALSE);
		radioNo.EnableWindow(FALSE);
	}
}

void CPushSettings::OnOK()
{
	//
    // It reads the registry too
    //
	CommunicationRegSettings regsettings(false);

    CString s1(""); _bstr_t bst;
    bool deRegisterSms  =false;
    bool registerSms    =false;
    bool deRegisterTcp  =false;
    bool registerTcp    =false;

	//-- sms & tcp/ip
	if(checkSms.GetCheck() == BST_UNCHECKED)
    {     
        if(regsettings.cs.getSms() == "1")
            deRegisterSms = true;
		regsettings.cs.setSms(CString("0"));
    }
	else
	{
        if(regsettings.cs.getSms() == "0")
            registerSms = true;

		if(radioYes.GetCheck() == BST_CHECKED)
			regsettings.cs.setSms(CString("2"));
		else
			regsettings.cs.setSms(CString("1"));
	};

	if(checkTcpIp.GetCheck() == BST_UNCHECKED)
    {
        if(regsettings.cs.getPush() == "1")
            deRegisterTcp = true;
		regsettings.cs.setPush(CString("0"));
    }
	else
	{
        if(regsettings.cs.getPush() == "0")
            registerTcp = true;

		if(radioYes.GetCheck() == BST_CHECKED)
			regsettings.cs.setPush(CString("2"));
		else
			regsettings.cs.setPush(CString("1"));
	}

	//-- pushPort
	GetDlgItemText(IDC_PUSH_EDIT_PORT, s1);
    if(regsettings.cs.getPushPort() != s1)
    {
        //-- the port has changed
        deRegisterTcp = true; registerTcp = true;
    };
    regsettings.cs.setPushPost(s1);
	
	//-- if user checked Server Push, he must choose also a notification type (Sms / TcpIP)
	bool bDoNotSave=false;
	if(checkServerPush.GetCheck() == BST_CHECKED)
	{
		if((checkSms.GetCheck() == BST_UNCHECKED) &&
			(checkTcpIp.GetCheck() == BST_UNCHECKED))
		{ 
			bDoNotSave = true;
			s1.LoadString(IDS_PUSH_CHOOSE_NOTIFTYPE);    
            CString stext("Funambol Alert");
			MessageBox(s1, stext, MB_OK | MB_ICONWARNING); //AfxMessageBox(s1);
		};
	}
	else
	{
		//-- serverPush unchecked
		regsettings.cs.setPush(CString("0"));  regsettings.cs.setSms(CString("0"));
        deRegisterSms = true; deRegisterTcp = true;
        registerSms = false; registerTcp = false;
	}

	//-- if user has checked tcpip notification, then he must choose a port
	if( checkTcpIp.GetCheck() == BST_CHECKED)
	{
		GetDlgItemText(IDC_PUSH_EDIT_PORT,s1);
		if(s1.IsEmpty())
		{
			s1.LoadString(IDS_PUSH_CHOOSE_PORT);
			AfxMessageBox(s1);
			bDoNotSave = true;
		}
	}

    if(! bDoNotSave)
    {   
        if (deRegisterSms && deRegisterTcp && 
            !registerSms && !registerTcp ) {            
            regsettings.cs.setSvrNotified(CString("0"));
        }

       if(!checkStartSync()){
            regsettings.writeToRegistry();
      
              //-- check if tcp and sms settings have changed, and register/deregister  sms and tcp/ip push
        // TODO: check for errors
        if (deRegisterSms)
        { 
           startProgram(_T("startsync.exe"),_T("deregister"));
        };

        if (registerSms)
        { 
            startProgram(_T("startsync.exe"),_T("register"));
        };
       } // end check StartSync

        if(deRegisterTcp && registerTcp)
        {
            // -- re-register (the port has changed)
            startProgram(_T("handleservice.exe"),_T("deregister")); //wait
            startProgram(_T("handleservice.exe"),_T("register"));
        }
        else
        {
            if (deRegisterTcp)
            {
                startProgram(_T("handleservice.exe"),_T("deregister"));
            };
            if (registerTcp)
            { 
                startProgram(_T("handleservice.exe"),_T("register"));
            };
        }

        CDialog::OnOK();
    } // -- end saving data
}
void CPushSettings::OnPushCheckTcpipClicked()
{
	if(checkTcpIp.GetCheck() == BST_CHECKED)
		editPort.EnableWindow(TRUE);
	else
		editPort.EnableWindow(FALSE);
}


#ifdef WIN32_PLATFORM_WFSP
LRESULT CPushSettings::OnHotkey(WPARAM wParam, LPARAM lParam)
{
	if (HIWORD(lParam) == VK_TBACK)
		SHSendBackToFocusWindow(WM_HOTKEY, wParam, lParam);
	return 0;
}
#endif