/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "stdafx.h"
#include "RegistrySettings.h"
#include "ClientUtil.h"
#include "spds/constants.h"

#include "examples/config.h"
#include "base/fscapi.h"
#include "spds/constants.h"
#include "spdm/DMTree.h"
#include "spdm/DMTreeFactory.h"
#include "spdm/ManagementNode.h"
#include "ClientSettings.h"
#include "pim/Utils.h"

#include "notify/checknet.h" //-- for IP



//----------------- Communication Registry Settings -------------------
CommunicationRegSettings::CommunicationRegSettings(BOOL toClose) : cs((char*) APPLICATION_URI) {    
    cs.readConfig(toClose);  
}

CommunicationRegSettings::~CommunicationRegSettings() { }

void CommunicationRegSettings::readFromRegistry() {	
           
	//--get IP
	//if(IsNetPresent())
	
	wchar_t* ip = new wchar_t[255];	
    //wcscpy(ip, TEXT("127.0.0.1"));

    if(checkNetwork()) { //-- this could take time
		getIPAddress(ip);	 // TODO       	
    } else {
        wcscpy(ip, TEXT("127.0.0.1"));
    }
    CString cc(ip);
    cs.setIp(cc);
    delete[] ip; 
    ip = NULL;	
	  
}

void CommunicationRegSettings::writeToRegistry() {
    cs.saveConfig();   
}


SyncRegSettings::SyncRegSettings(const char* sourceType, BOOL toClose) : cs((char*) APPLICATION_URI) {
    cs.readConfigSources(sourceType, toClose);  
}

SyncRegSettings::~SyncRegSettings() {}
	

void SyncRegSettings::writeToRegistry(const char* saveAll, bool alsoLast) {
    cs.saveConfigSources(saveAll, alsoLast);
}


