/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "stdafx.h"
#include "ui.h"
#include "uiDlg.h"
#include "CommunicationSettings.h"
#include "LoglevelSettings.h"
#include "RecoverSettings.h"
#include "About.h"
#include "PushSettings.h"
#include "LogViewer.h"
#include "SyncSettings.h"
#include "RegistrySettings.h"
#include "pim/maincpp.h"
#include "shellapi.h"

#include "SynchronizationMessages.h"

#include "Shellapi.h"
#include "aygshell.h"
#include "pim/SettingFunctions.h"
#include "ClientUtil.h"

#include "base/util/utils.h"
#include "SyncResults.h"
#include <windows.h>

#include "comutil.h" //bstr
#include "HwndFunctions.h"
#include "notify/timed_msgbox.h"

#define ITEMS_FROM_SERVER 20

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

long retValueLastSync=0;
bool isServerConfigured();

CuiDlg::CuiDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CuiDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

//--- my handlers to menu opts
void CuiDlg::OnMenuComm()
{
	#ifdef WIN32_PLATFORM_WFSP
		//dlgCommandBar.Show(false); dlgCmdBarStop.Show(false);
	#endif

	CCommunicationSettings wndCommSett;
	INT_PTR result = wndCommSett.DoModal();
    //if(result == CLOSE_THIS_DIALOG)
      //  this->EndDialog(CLOSE_THIS_DIALOG);
	
	#ifdef WIN32_PLATFORM_WFSP
		if(checkStartSync())
			dlgCmdBarStop.Show(true);
		else
			dlgCommandBar.Show(true); 
	#endif
    
   ShowWindow(TRUE);
}

void CuiDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    #ifdef WIN32_PLATFORM_WFSP
	    DDX_Control(pDX, IDC_IMG_FUNLOGO, imageLogo);
    #endif
    DDX_Control(pDX, IDC_MAIN_PROGRESS, progressBar);
}

BEGIN_MESSAGE_MAP(CuiDlg, CDialog)
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	    ON_WM_SIZE()
    #endif
	ON_COMMAND(IDM_COMM, OnMenuComm)
	//}}AFX_MSG_MAP
   ON_COMMAND(IDM_LOGLEVEL, &CuiDlg::OnMenuLoglevel)
   ON_COMMAND(ID_SYNC, &CuiDlg::OnSync)
   ON_COMMAND(ID_MENU_EXIT, &CuiDlg::OnMenuExit)
   ON_COMMAND(ID_RECOVER, &CuiDlg::OnMenuRecover)
   ON_MESSAGE(ID_MYMSG_UPDATE_PROGBAR, &CuiDlg::OnMsgUpdateProgressBar)
   ON_MESSAGE(ID_MYMSG_STARTSYNC_ENDED, &CuiDlg::OnStartsyncEnded)
   ON_MESSAGE(ID_MYMSG_STARTING_SYNC, &CuiDlg::OnStartingSync)
   ON_MESSAGE(ID_MYMSG_SOURCES_NUMBER, &CuiDlg::OnMsgSourcesNumber)
   ON_MESSAGE(ID_MYMSG_STARTING_SOURCE, &CuiDlg::OnStartingSource)
   ON_MESSAGE(ID_MYMSG_ITEM_SYNCED_FROM_SERVER, &CuiDlg::OnMsgItemSyncedFromServer)
   ON_MESSAGE(ID_MYMSG_ITEM_SYNCED_FROM_CLIENT, &CuiDlg::OnMsgItemSyncedFromClient)
   ON_MESSAGE(ID_MYMSG_TOTAL_ITEMS, &CuiDlg::OnMsgTotalItems)
   ON_COMMAND(ID_MENU_ABOUT, &CuiDlg::OnMenuAbout)
   ON_COMMAND(IDABORT, &CuiDlg::OnMenuStop)
   ON_COMMAND(ID_SETTINGS_PUSHSETTINGS, &CuiDlg::OnMenuPush)
   ON_COMMAND(ID_SETTINGS_SYNC, &CuiDlg::OnMenuSync)
   ON_WM_ENTERMENULOOP()
   ON_WM_EXITMENULOOP()
END_MESSAGE_MAP()


// CuiDlg message handlers

BOOL CuiDlg::OnInitDialog()
{
	CString s1;
	s1.LoadString(IDS_FUNAMBOL); SetWindowText(s1);
	CDialog::OnInitDialog();
        
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	
	SetIcon(m_hIcon, TRUE);			// Set big icon	
	SetIcon(m_hIcon, FALSE);		// Set small icon

  #ifdef WIN32_PLATFORM_WFSP
	if (!dlgCommandBar.Create(this) ||
	    !dlgCommandBar.InsertMenuBar(IDR_MAINFRAME) || 
		!dlgCmdBarStop.Create(this)  ||
        !dlgCmdBarStop.InsertMenuBar(IDR_MENUBAR_STOP) ||
        !dlgCmdBarMenu.Create(this)  ||
        !dlgCmdBarMenu.InsertMenuBar(IDR_MAINFRAME1) 
		)
	{
		return FALSE;      // failed to create
	} 

	dlgCommandBar.Show(true);
    dlgCmdBarStop.Show(false);
    dlgCmdBarMenu.Show(false);

    //-- main Funambol logo
    if(GetDeviceCaps(this->GetDC()->GetSafeHdc(), LOGPIXELSX) < 131)
        bmpBitmap.LoadBitmap(IDB_BITMAP1);  // dpi < 131
    
    else
        bmpBitmap.LoadBitmap(IDB_BITMAP2);  // dpi >= 131
    imageLogo.SetBitmap(bmpBitmap);
  #else
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDR_MENU1; 
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!\n\nOnInitDialog")); 
        return FALSE;
    }
  #endif 

    progressBar.SetPos(0);
    progressBar.SetStep(5);
  //-- check if another sync is in progress
	if(checkStartSync() != 0)
	{
		//s1.LoadString(IDS_MAIN_SYNCINPROGRESS);
        s1 = "Sync in progress...";
		SetDlgItemText(IDC_MAIN_MSG, s1);
		//progressBar.ShowWindow(TRUE);

        #ifdef WIN32_PLATFORM_WFSP
		    //-- show menu with stop
            dlgCommandBar.Show(false);
		    dlgCmdBarStop.Show(true);
        #endif

        #if defined(WIN32_PLATFORM_PSPC)
            CreateMenuBar(IDM_STOP);
            progressBar.ShowWindow(FALSE);
        #endif

		bSyncStarted = true;
	}
	else
	{
		progressBar.ShowWindow(FALSE);
		bSyncStarted = false;
    }
	
 #if defined WIN32_PLATFORM_WFSP
    if( (GetDeviceCaps(this->GetDC()->GetSafeHdc(),HORZRES) == 320) &&
        (GetDeviceCaps(this->GetDC()->GetSafeHdc(),VERTRES) == 240) &&
        (GetDeviceCaps(this->GetDC()->GetSafeHdc(),LOGPIXELSX) == 131) &&
        (GetDeviceCaps(this->GetDC()->GetSafeHdc(),LOGPIXELSY) == 131)  )
    {
        // 320x240 screens
        bmpBitmap.LoadBitmap(IDB_BITMAP1);
        imageLogo.SetBitmap(bmpBitmap);
        
        int leftPosition = (GetDeviceCaps(this->GetDC()->GetSafeHdc(),HORZRES) / 2) - 65; // the middle of 131
        imageLogo.SetWindowPos(&CWnd::wndTop, leftPosition,8,0,0, SWP_NOSIZE);

        progressBar.SetWindowPos(&CWnd::wndTop, 60,140,0,0, SWP_NOSIZE);    
        
        CRect rect; 
        GetWindowRect(&rect); 
        ScreenToClient(&rect);
        GetDlgItem(IDC_MAIN_MSG)->SetWindowPos(GetActiveWindow(), rect.TopLeft().x, rect.TopLeft().y + 160, 
                                               rect.Width(), rect.Height() - 160, SWP_SHOWWINDOW);
        
        //staticSyncMsg.SetWindowPos(&CWnd::wndTop, 48,128,0,0, SWP_NOSIZE);
        //progressBar.SetWindowPos(&CWnd::wndTop, 48,150,0,0, SWP_NOSIZE);
    }
    else
    {
    //-- main Funambol logo
        if(GetDeviceCaps(this->GetDC()->GetSafeHdc(), LOGPIXELSX) < 131){
		bmpBitmap.LoadBitmap(IDB_BITMAP1);  // dpi < 131
            imageLogo.SetBitmap(bmpBitmap);
            //imageLogo.SetWindowPos(&CWnd::wndTop, 22,10,0,0, SWP_NOSIZE);
        }
	else
        {
		bmpBitmap.LoadBitmap(IDB_BITMAP2);  // dpi >= 131
	    imageLogo.SetBitmap(bmpBitmap);
        
        }
    }
 #endif
	
    currentSource = 0;
    totalSources = 0;
    resetCurrentItem = true;
    lastItem = 0;
    currentItem = 0;
    lastSource = -1;
    totalItems = 0;
    lastSourceIsFromClient = true;
    updatedPbar = false;
    
    isInSettings = false;
    syncStartedFromUI = false;
    return TRUE;  
}     //---------- end OnInitDialog


#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CuiDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
    int resId;
    CString s1;
    switch(DRA::GetDisplayMode())
    {
    case DRA::Landscape:
        resId = IDD_UI_DIALOG_WIDE; break;
    case DRA::Portrait:
        resId = IDD_UI_DIALOG; break;
    case DRA::Square:
        resId = IDD_UI_DIALOG_SQUARE; break;
    default:
        resId = IDD_UI_MAIL; break;
    };

    GetDlgItemText(IDC_MAIN_MSG, s1); // store label text
    DRA::RelayoutDialog( AfxGetInstanceHandle(), this->m_hWnd, MAKEINTRESOURCE(resId));
    SetDlgItemText(IDC_MAIN_MSG, s1); // restore label text
}
#endif

void CuiDlg::OnMenuLoglevel()
{
	#ifdef WIN32_PLATFORM_WFSP
		//dlgCommandBar.Show(false); dlgCmdBarStop.Show(false);
	#endif
	CLoglevelSettings wndLoglevel;
	INT_PTR result = wndLoglevel.DoModal();
	
	#ifdef WIN32_PLATFORM_WFSP
		if(checkStartSync())
			dlgCmdBarStop.Show(true);
		else
			dlgCommandBar.Show(true);
	#endif
}

void CuiDlg::OnSync()
{
   CString s2;
   int check  = checkStartSync();
   int ret;
   lastSourceIsFromClient = true;

    if (!isServerConfigured()) {
        HwndFunctions::closePreviousMsgBox();
        TimedMessageBox(GetSafeHwnd(), _T("Please set the Funambol Server URL"), _T("Funambol alert"), MB_OK | MB_ICONHAND, INFINITE);
        OnMenuComm();

    } else if(check == 0) {
		ret = startProgram(SYNCAPP, TEXT("once"));	 //-- start sync process
		if (ret == -5)
		{
            HwndFunctions::closePreviousMsgBox();
            TimedMessageBox(GetSafeHwnd(), _T("'startsync.exe' was not found. Please reinstall the application"),_T("Funambol alert"), MB_OK | MB_ICONHAND, INFINITE);
		}
		else
		{
			progressBar.ShowWindow(TRUE);
            #ifdef WIN32_PLATFORM_WFSP
			    //-- show menu with stop
			    dlgCommandBar.Show(false);
			    dlgCmdBarStop.Show(true);
            #else
                dlgCommandBar.nToolBarId = IDM_STOP;
                if(!SHCreateMenuBar(&dlgCommandBar)){
                    AfxMessageBox(_T("Cannot create command bar!")); 
                    return ;
                }
            #endif
            syncStartedFromUI = true;
		}
	};
}


void CuiDlg::OnMenuExit()
{
    int ret = EndAppQuery(GetSafeHwnd());
    if((ret == 0) || (ret== 1))
        CDialog::OnOK();
}


void CuiDlg::OnMenuRecover()
{
	#ifdef WIN32_PLATFORM_WFSP
		//dlgCommandBar.Show(false);	dlgCmdBarStop.Show(false);
	#endif
	CRecoverSettings wndRecover;
    //isInSettings = true;
	INT_PTR result = wndRecover.DoModal();
    if(result == 1) // the user started a recover sync
        syncStartedFromUI = true;
    isInSettings = false;
	
	#ifdef WIN32_PLATFORM_WFSP
		if(checkStartSync())
			dlgCmdBarStop.Show(true);
		else
			dlgCommandBar.Show(true);
	#endif
}

LRESULT CuiDlg::OnMsgUpdateProgressBar(WPARAM , LPARAM lParam)
{
    int upper, lower;
    progressBar.GetRange(lower, upper);
    int step = (upper-lower-10)/2/totalSources;

    if(lParam == -2) //-- for msg "Authentication in progress..."
    {
        CString msg("Authentication in progress...");
        SetDlgItemText(IDC_MAIN_MSG, msg);
    }
    else
    if(lParam == -3) //-- for msg "Ending sync..."
    {
        int endStep = 95 - progressBar.GetPos();
        if(endStep > 0)
            progressBar.OffsetPos(endStep);   
     
        CString msg("Ending sync...");
        SetDlgItemText(IDC_MAIN_MSG, msg);   
    }
    else
    if(lParam == -1) //-- sync source ended event
    {
        if( ((totalItems == 0) || (!updatedPbar))  && (lastSource == -1))
        {
            /* sync source ended, update progressbar, but only for modifs from client
                (lastSource > 0)
            */

            progressBar.OffsetPos(step);   
            updatedPbar = true;
        };
        
        //totalItems = -1; //?!
        //lastSource = -1;  //!!
        lastItem = currentItem;

    }
    else
    {
        //-- step progressbar with <lParam> steps
        if(lParam > 0)
            progressBar.SetStep(lParam);
        progressBar.StepIt();
    };
    
  return 0;
}

/////
LRESULT CuiDlg::OnStartsyncEnded(WPARAM wParam, LPARAM lParam) {
    CString s1("");
    SetDlgItemText(IDC_MAIN_MSG,s1);

    int lower, upper;
    progressBar.GetRange(lower,upper);
    progressBar.SetPos(upper);
    progressBar.ShowWindow(FALSE);
    progressBar.SetPos(lower);

    if(!isInSettings){
        #if defined(WIN32_PLATFORM_WFSP)
	        //-- show menu with stop
	        dlgCommandBar.Show(true);
	        dlgCmdBarStop.Show(false);
        #else
            CreateMenuBar(IDR_MENU1);
        #endif
    }

    retValueLastSync = lParam;

    // if it is zero ('success'), show the syncresults.txt file:
    if ( (retValueLastSync == 0) || (retValueLastSync == 10003) ) {
        CString message;  message.LoadString(IDS_CODE_OK_0);
        SetDlgItemText(IDC_MAIN_MSG,message);
        /*
        // show the sync result.
        CLogViewer wndLogViewer;
        s1.LoadString(IDS_SYNCRESULTS);
        //dlgCommandBar.Show(false); dlgCmdBarStop.Show(false);
        wndLogViewer.setFile("\\syncresults.txt");
        wndLogViewer.setIsSyncResults(true);

        if( (!isInSettings) && (syncStartedFromUI) ){
            INT_PTR result = wndLogViewer.DoModal();
        };

        #ifdef WIN32_PLATFORM_WFSP
        if(checkStartSync())
            dlgCmdBarStop.Show(true);
        else
            dlgCommandBar.Show(true);
        #endif
        */
   
    }
    else if (retValueLastSync == -20) { // the user block the sync to avoid the slow
        // nothing to display
    }
    else {
     
        CString message;  message.LoadString(IDS_CODE_ERROR_NOT_DONE);
        CString errormsg = SyncErrorMsg(retValueLastSync);
        
        /*
        * Add info to put in the error message the directory that doesn't exists.
        * It needs for briefcase or notes
        */
        if (retValueLastSync == -25 || retValueLastSync == -26) { // briefcase dir doesn't exist
            CString s;
            if (retValueLastSync == -25) {
                SyncRegSettings regsettings("briefcase");
                s = regsettings.cs.getDir();                                    
            } else if (retValueLastSync == -26) {
                SyncRegSettings regsettings("note");
                s = regsettings.cs.getDir();   
            }
            if (s.GetLength() > 24)
                s = "";
            errormsg += s;
            s.LoadString(IDS_CODE_DOESNT_ESIST);
            errormsg += s;                        
        } 

        #ifdef WIN32_PLATFORM_WFSP
            HwndFunctions::closePreviousMsgBox();
            // TODO: maybe change to TimedMsgBox
            if(errormsg != "")
                AfxMessageBox(errormsg);
            else
                AfxMessageBox(message); 
        #else
            if(errormsg != "")
                SetDlgItemText(IDC_MAIN_MSG,errormsg);
	        else
                SetDlgItemText(IDC_MAIN_MSG,message);
        #endif
    } // endif (sync errorcode)
 
    bSyncStarted = false;
    syncStartedFromUI = false;
    //-- reset variables
    currentSource = 0;
    totalSources = 0;
    resetCurrentItem = true;
    totalItems = 0;
    lastItem = 0;
    lastSource = -1;
    updatedPbar = false;

    return 0;
}

LRESULT CuiDlg::OnStartingSync(WPARAM, LPARAM)
{
  CString s2;

  if(!isInSettings){
      HwndFunctions::closePreviousMsgBox();
    progressBar.ShowWindow(TRUE);
    
    #ifdef WIN32_PLATFORM_WFSP
      //-- show menu with stop
      dlgCommandBar.Show(false);
      dlgCmdBarStop.Show(true);
    #else
        CreateMenuBar(IDM_STOP);
    #endif
  }

    s2.LoadString(IDS_MAIN_SYNCINPROGRESS);
    SetDlgItemText(IDC_MAIN_MSG, s2);	

    bSyncStarted = true;
    return 0;
}

LRESULT CuiDlg::OnMsgSourcesNumber(WPARAM wParam, LPARAM lParam)
{
    totalSources = lParam;
    return 0;
}

void CuiDlg::OnMenuAbout()
{
	#ifdef WIN32_PLATFORM_WFSP
	   //dlgCommandBar.Show(false); dlgCmdBarStop.Show(false);
	#endif

	CAbout wndAbout;
    isInSettings = true;
	INT_PTR result = wndAbout.DoModal();
    isInSettings = false;

	#ifdef WIN32_PLATFORM_WFSP
		if(checkStartSync())
			dlgCmdBarStop.Show(true);
		else
			dlgCommandBar.Show(true);
	#endif
}

void CuiDlg::OnMenuStop()
{
    int ret = EndAppQuery(GetSafeHwnd());	
    // If startsync was not running simulate the message. 
    // 1 - sync not running
    // 0 - user choosed to stop the sync, we need to call OnStartsyncEnded
    //       to reset the controls
    if(ret== 0) {
	    OnStartsyncEnded(NULL, (LPARAM) -20 ); // nothing to show...
    }
    else if (ret== 1){
        OnStartsyncEnded(NULL, (LPARAM) -6 );
    }
    
}

void CuiDlg::OnMenuPush()
{
  CPushSettings wndPushSettings;

  #ifdef WIN32_PLATFORM_WFSP
	//dlgCommandBar.Show(false); dlgCmdBarStop.Show(false);
  #endif

  isInSettings = true;
  INT_PTR result = wndPushSettings.DoModal();
  isInSettings = false;

  #ifdef WIN32_PLATFORM_WFSP
    if(checkStartSync())
      dlgCmdBarStop.Show(true);
    else
      dlgCommandBar.Show(true);		
  #endif
}

void CuiDlg::OnMenuSync()
{
    #ifdef WIN32_PLATFORM_WFSP
        //dlgCommandBar.Show(false); 
        dlgCmdBarStop.Show(false);
    #endif

    CSyncSettings wndSyncSettings;
    isInSettings = true;
    INT_PTR result = wndSyncSettings.DoModal();
    isInSettings = false;

    #ifdef WIN32_PLATFORM_WFSP
        if(checkStartSync()) 
            dlgCmdBarStop.Show(true);
        else
            dlgCommandBar.Show(true);		
    #endif
}

void CuiDlg::OnEnterMenuLoop(BOOL bIsTrackPopupMenu)
{
    #ifdef WIN32_PLATFORM_WFSP
        dlgCommandBar.Show(false);
        dlgCmdBarMenu.Show(true);
    #endif
}

void CuiDlg::OnExitMenuLoop(BOOL bIsTrackPopupMenu)
{
    #ifdef WIN32_PLATFORM_WFSP
        dlgCmdBarMenu.Show(false);
        dlgCommandBar.Show(true);
    #endif
}

void CuiDlg::OnInitMenuPopup(CMenu* pPopupMenu,UINT nIndex,BOOL bSysMenu)
{
   // dlgCommandBar.Show(false);
   //dlgCmdBarMenu.Show(TRUE);
}

LRESULT CuiDlg::OnStartingSource(WPARAM wParam, LPARAM lParam)
{
    CString msg("Sending ");
    switch(lParam)
    {
    case CURRENT_SOURCE_MAIL:
        msg+="mail"; break;
    case CURRENT_SOURCE_CALENDAR:
        msg+="calendar"; break;
    case CURRENT_SOURCE_CONTACT:
        msg+="contacts"; break;
    case CURRENT_SOURCE_TASK:
        msg+="tasks"; break;
    case CURRENT_SOURCE_BRIEFCASE:
        msg+="files"; break;
    case CURRENT_SOURCE_NOTES:
        msg+="notes"; break;
    }
    SetDlgItemText(IDC_MAIN_MSG,msg);
    currentSource = lParam;
       

    //lastSource = -1;
    //if(currentSource != lastSource)
    updatedPbar = false;
    return 0;
}

// not a WM_APP message handler
void CuiDlg::OnMsgItemSynced(WPARAM wParam, LPARAM lParam, bool fromClient)
{
    bool changeLabel = true;
    int source=-1;

    if(lParam > 0)
        currentItem = lParam;

    if ( (wParam == -1) && (lParam == -1) ){
        // just increase the progressbar, do not change the label
        changeLabel = false;
        currentItem++;
    }

    if( (wParam > 0)  && (currentSource != wParam) )  // extra check
    {
        resetCurrentItem = true;
        lastItem = 0;
    };

    CString msg("");

    if( fromClient )
        msg+="Sending ";
    else
        msg+="Receiving ";  

    source = wParam;
    currentSource = source;

    /*if( (lastSourceIsFromClient && fromClient) || 
        (!lastSourceIsFromClient && !fromClient) )
        resetCurrentItem = false;
    else
        resetCurrentItem = true;*/
        
    if( (!resetCurrentItem) && (lParam != 0) )  // the server sent more valid noc's for the same source
       currentItem =lastItem+lParam;
    

    switch(source)
    {
    case CURRENT_SOURCE_MAIL:
        msg+="mail"; break;
    case CURRENT_SOURCE_CALENDAR:
        msg+="calendar"; break;
    case CURRENT_SOURCE_CONTACT:
        msg+="contact"; break;
    case CURRENT_SOURCE_TASK:
        msg+="task"; break;
    case CURRENT_SOURCE_BRIEFCASE:
        msg+="file"; break;
    case CURRENT_SOURCE_NOTES:
        msg+="note"; break;

    default:
        msg = "";
    }

    if(msg == "")
        goto finally;
    msg+=" ";    
    
    char* v = ltow(currentItem); 
    msg+=v;
    delete [] v; v = NULL;

    if(totalItems != -1)
    {
        msg+="/"; 
        char* v = ltow(totalItems);
        msg+=v;
        delete [] v; v = NULL;
    }

    if((currentItem > totalItems) && (totalItems != -1) ) 
        goto finally;

    if(changeLabel)
        SetDlgItemText(IDC_MAIN_MSG,msg);

    if ((totalItems == -1) && (currentItem > ITEMS_FROM_SERVER)) // noc==-1, suppose items to be synced=ITEMS_FROM_SERVER
        goto finally;

   
    if(totalItems != 0) //
    {
        int upper,lower;
        progressBar.GetRange(lower,upper);
        if(totalSources != 0)
        {
            double step1 = 0.0;
            int step2 = 0;
            /* 
                if totalItems == -1, then noc is not OK, we assume it's ITEMS_FROM_SERVER
                for mail we step more than for other sources
            */
            if(totalItems == -1)
                step1 = (double)((double)(upper-lower-10)/(double)totalSources/2/(double)ITEMS_FROM_SERVER);
            else
                step1 = (double)((double)(upper-lower-10)/(double)totalSources/2/(double)totalItems);
            /*
                if the step is between 0 and 1, we set it to 1, and update the
                progressbar only once in a few items synced

                step * X = 1;
                if (currentItemNumber % X == 0)  then Step
            */
            if( (step1<1) && (step1>0)) 
            {
                int newStep = (int)(1/step1);
                if( (step1 >= 0.5) && (step1 <= 0.75)) // TODO: 
                    newStep = 2; 
                if(lParam % newStep == 0)
                {
                   progressBar.OffsetPos(1);
                   updatedPbar = true;
                };
            }
            else
            {
                if(totalItems == -1)
                    step2 = (upper-lower-10)/totalSources/2/ITEMS_FROM_SERVER;
                else
                    step2 = (upper-lower-10)/totalSources/2/totalItems;
                
                progressBar.OffsetPos(step2);
                updatedPbar = true;
            }
        }
    }

    finally:

    return;

}

LRESULT CuiDlg::OnMsgItemSyncedFromServer( WPARAM wParam, LPARAM lParam)
{
    OnMsgItemSynced(wParam,lParam, false);
    return 0;
}

LRESULT CuiDlg::OnMsgItemSyncedFromClient( WPARAM wParam, LPARAM lParam)
{
    OnMsgItemSynced(wParam, lParam, true);
    return 0;
}


LRESULT CuiDlg::OnMsgTotalItems(WPARAM wParam, LPARAM lParam)
{
    CString msg("Receiving ");
    bool changeLabel = false;
    int sourceNumber = wParam;
    if ( (sourceNumber != -1) && (sourceNumber > 0) )   // wParam > 0, then the modifs are from server
    {
        if (sourceNumber != currentSource)    // a new source from server
        {
            // begin a new source from server, update the progress bar for the previous source
            changeLabel = true;

            if((currentItem < ITEMS_FROM_SERVER) && (currentItem > 0) && (totalItems == -1))
            {
                /* syncSourceTotalServerItems supplied -1, so if the number of synced
                   items is less than ITEMS_FROM_SERVER, step the remaining of the progressbar for
                   (ITEMS_FROM_SERVER - currentItem-1) items
                 */
                /*for(int i=currentItem+1; i<= ITEMS_FROM_SERVER; i++)
                    this->OnMsgItemSynced((WPARAM) -1, (LPARAM) -1);*/
                StepProgBar(currentItem+1);
                updatedPbar = true;
                currentItem = 0;
                lastItem = 0;
            };
            if( (!updatedPbar) && (sourceNumber != -1))
            {
                int upper, lower;
                progressBar.GetRange(lower, upper);
                int step = (upper-lower-10)/2/totalSources;

                progressBar.OffsetPos(step);   
                updatedPbar = false;
            };
            totalItems = lParam;
            resetCurrentItem = true;
            lastItem = 0;
            currentItem = 0;
            updatedPbar = false;
            currentSource = sourceNumber;
        } 
        else        
        {
           /*
            wParam == currentSource, one of more syncSourceTotalServerItems events for
            the same source, or there is only one source to be synced
             (lastSource == -1) for sources from client
             (lastSource > 0) for sources from server, here lastSource is the source code
           */
           if(lastSource < 0)  // (wParam>0) && (lastSource<0) => first source from server
           {
               resetCurrentItem = true;
               totalItems = lParam;
               lastItem = 0;
               currentItem = 0;
               changeLabel = true;
           }
           else
           {
               resetCurrentItem = false;
               lastItem = currentItem;
           }
        }; 
    } //if wParam < 0
    else if(wParam == -1)
    {
        totalItems = lParam;    // source from client, total items are ok
    }

    //-- 

    lastSource = sourceNumber;
    //lastSource = currentSource;
    //lastItem  = currentItem;

   
    switch(wParam)
    {
    case CURRENT_SOURCE_MAIL:
        msg+="mail"; break;
    case CURRENT_SOURCE_CALENDAR:
        msg+="calendar"; break;
    case CURRENT_SOURCE_CONTACT:
        msg+="contacts"; break;
    case CURRENT_SOURCE_TASK:
        msg+="tasks"; break;
    case CURRENT_SOURCE_BRIEFCASE:
        msg+="files"; break;
    case CURRENT_SOURCE_NOTES:
        msg+="notes"; break;
    default:
        msg = ""; break;
    }
    if( (msg!="") &&  changeLabel) // !
    {
        SetDlgItemText(IDC_MAIN_MSG,msg);
    }


    return 0;
}

void CuiDlg::StepProgBar(int from)
{
  for(int i=from; i<=ITEMS_FROM_SERVER; i++ )
  {
    int upper,lower;
    progressBar.GetRange(lower,upper);
    if(totalSources != 0)
    {
        double step1 = 0.0;
        int step2 = 0;
        /* 
        if totalItems == -1, then noc is not OK, we assume it's ITEMS_FROM_SERVER
        for mail we step more than for other sources
        */
        if(totalItems == -1)
            step1 = (double)((double)(upper-lower-10)/(double)totalSources/2/(double)ITEMS_FROM_SERVER);
        else
            step1 = (double)((double)(upper-lower-10)/(double)totalSources/2/(double)totalItems);
        /*
        if the step is between 0 and 1, we set it to 1, and update the
        progressbar only once in a few items synced

        step * X = 1;
        if (currentItemNumber % X == 0)  then Step
        */
        if( (step1<1) && (step1>0)) 
        {
            int newStep = (int)(1/step1);
            if( (step1 >= 0.5) && (step1 <= 0.75)) // TODO: 
                newStep = 2; 
            if(i % newStep == 0)
            {
                progressBar.OffsetPos(1);
                updatedPbar = true;
            };
        }
        else
        {
            if(totalItems == -1)
                step2 = (upper-lower-10)/totalSources/2/ITEMS_FROM_SERVER;
            else
                step2 = (upper-lower-10)/totalSources/2/totalItems;

            progressBar.OffsetPos(step2);
            updatedPbar = true;
        }
    }
  }
}


#if defined(WIN32_PLATFORM_PSPC) 
void CuiDlg::CreateMenuBar(const int id){
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO); 
    dlgCommandBar.hwndParent = this->GetSafeHwnd(); 
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = id; 
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0; 
    dlgCommandBar.cBmpImages = 0; 
    if(!SHCreateMenuBar(&dlgCommandBar)){
        AfxMessageBox(_T("Cannot create command bar!\n\n")); 
    }
}
#endif

void CuiDlg::OnOK()
{
    /*HWND wnd = ::FindWindow(TEXT("funambolstartsync"), NULL);
    if (checkStartSync() != 0){
        // sync is in progress
        CString s1; s1.LoadString(IDS_SYNC_IN_PROGRESS);
        int retMsgBox = AfxMessageBox(s1);
    }*/
    this->ShowWindow(SW_MINIMIZE);
}
bool isServerConfigured() {

    CommunicationRegSettings regsettings;
	CString s1;
	regsettings.readFromRegistry();	
    s1 = regsettings.cs.getAccessConfig().getSyncURL();        
    if(s1.Find(_T("<")) > 0)
        return false;
    else
        return true;

}

// override back key sph
void CuiDlg::OnCancel(){
    this->ShowWindow(SW_MINIMIZE);
}

