/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#pragma once

#include "ui.h"

// CLogViewer dialog

class CLogViewer : public CDialog
{
	DECLARE_DYNAMIC(CLogViewer)

public:
	CLogViewer(CWnd* pParent = NULL);   // standard constructor
	virtual ~CLogViewer();

// Dialog Data
	enum { IDD = IDD_UI_LOGVIEWER };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        SHMENUBARINFO dlgCommandBar;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        CCommandBar dlgCommandBar3;
    #endif

    CListBox editText;
    char* filename;
    bool isSyncResults;
    CBrush *brush;

    virtual BOOL OnInitDialog();  
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

DECLARE_MESSAGE_MAP()

public:
    int loadFile(const char* _filename);
    void setFile(const char* _filename);
    void setIsSyncResults(bool value);
    afx_msg HBRUSH OnCtlColor( CDC*, CWnd*, UINT );
};
