/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "events/SyncItemListenerClient.h" //--from clientdll/include

#include "event/SyncItemEvent.h"
//#include "event/SyncItemListener.h"

#include "event/ManageListener.h"
#include "HwndFunctions.h"
#include "SyncResults.h"

SyncItemListenerClient::SyncItemListenerClient()
{
}

SyncItemListenerClient::~SyncItemListenerClient()
{
}

void SyncItemListenerClient::itemAddedByClient(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "note"))
        source = CURRENT_SOURCE_NOTES;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, (WM_APP+9),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
}

void SyncItemListenerClient::itemAddedByServer(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "note"))
        source = CURRENT_SOURCE_NOTES;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    if (strcmp(event.getSourceName(), "mail") != 0) {
    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        //SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
        SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
}
}

void SyncItemListenerClient::itemDeletedByClient(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, (WM_APP+9),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
}

void SyncItemListenerClient::itemDeletedByServer(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "note"))
        source = CURRENT_SOURCE_NOTES;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    if (strcmp(event.getSourceName(), "mail") != 0) {
    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        //SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
        SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
}
}

void SyncItemListenerClient::itemUpdatedByClient(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "note"))
        source = CURRENT_SOURCE_NOTES;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, (WM_APP+9),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);

}

void SyncItemListenerClient::itemUpdatedByServer(SyncItemEvent &event)
{
    int source = 0;
    if(!strcmp(event.getSourceName(), "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(event.getSourceName(), "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(event.getSourceName(), "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(event.getSourceName(), "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(event.getSourceName(), "note"))
        source = CURRENT_SOURCE_NOTES;
    if(!strcmp(event.getSourceName(), "mail"))
        source = CURRENT_SOURCE_MAIL;

    if (strcmp(event.getSourceName(), "mail") != 0) {
    SyncResultsLogger.itemNumber++;
    if (HwndFunctions::wnd)
        //SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
        SendMessage(HwndFunctions::wnd, (WM_APP+7),(WPARAM) source, (LPARAM) SyncResultsLogger.itemNumber);
}
}
