/*
* Copyright (C) 2003-2006 Funambol
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "event/SyncSourceListener.h"
#include "event/SyncSourceEvent.h"
#include "event/constants.h"
#include "event/ManageListener.h"
#include "events/SyncSourceListenerClient.h"

#include "event/SyncEvent.h" //TODO: --msgbox, null etc
#include "HwndFunctions.h"
#include "SyncResults.h"

SyncSourceListenerClient::SyncSourceListenerClient() : SyncSourceListener() 
{
    sourceNumber = -1;
    ends=0;
    sc = 0;
}

void SyncSourceListenerClient::syncSourceBegin(SyncSourceEvent &event) 
{
    // TODO: set here source number, if it is the first, new step after authentication
    if(sourceNumber == -1)
    {
        sourceNumber = 0;
        SyncResultsLogger.itemNumber = 0;
        
    }
    else
    {
        sourceNumber++;
    }

    SyncResultsLogger.setCurrentSource(0); //reset value
    SyncResultsLogger.totalItems = 0;
}
                                                                                
void SyncSourceListenerClient::syncSourceEnd(SyncSourceEvent &event) 
{
    
        if (HwndFunctions::wnd)
            SendMessage(HwndFunctions::wnd, (WM_APP+2),NULL, (LPARAM) -1);

    ends++;
    SyncResultsLogger.itemNumber = 0;
}

void SyncSourceListenerClient::syncSourceSyncModeRequested(SyncSourceEvent &event) 
{
    wchar_t* t = toWideChar(event.getSourceName());        
    setSyncMode(t, event.getSyncMode());
    delete [] t; t = NULL;
}
void SyncSourceListenerClient::setSyncMode(wstring sourcename, long mode) {

    sc->sourcenames.push_back(sourcename);
    sc->modes.push_back(mode);
}
void SyncSourceListenerClient::syncSourceTotalClientItems  (SyncSourceEvent& event) {
    // not yet implemented
}

void SyncSourceListenerClient::syncSourceTotalServerItems  (SyncSourceEvent& event) {
    //wchar_t noc[10];
    //wsprintf(noc, TEXT("NOC: %i"), event.getData());
    //MessageBox (NULL, noc, TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);    
    
    int source = 0;
    char sourceName[25];
    strcpy(sourceName, event.getSourceName());
    if(!strcmp(sourceName, "contact"))
        source = CURRENT_SOURCE_CONTACT;
    if(!strcmp(sourceName, "calendar"))
        source = CURRENT_SOURCE_CALENDAR;
    if(!strcmp(sourceName, "task"))
        source = CURRENT_SOURCE_TASK;
    if(!strcmp(sourceName, "briefcase"))
        source = CURRENT_SOURCE_BRIEFCASE;
    if(!strcmp(sourceName, "mail"))
        source = CURRENT_SOURCE_MAIL;

    if(source != 0)
    {
        //-- send the total number of server items to sync
        if(HwndFunctions::wnd)
            SendMessage(HwndFunctions::wnd, (WM_APP+8),(WPARAM) source,(LPARAM) event.getData());
    }

}
